---
title: Geolocation.watchPosition()
slug: Web/API/Geolocation/watchPosition
tags:
  - API
  - Geolocation
  - Geolocation API
  - Method
  - Reference
  - Secure context
---
<p>{{securecontext_header}}{{ APIref("Geolocation API") }}</p>

<p><span class="seoSummary">The {{domxref("Geolocation")}} method <strong><code>watchPosition()</code></strong> method is used to register a handler function that will be called automatically each time the position of the device changes.</span> You can also, optionally, specify an error handling callback function.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">navigator.geolocation.watchPosition(<var>success</var>[, <var>error</var>[, <var>options</var>]])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>success</var></code></dt>
 <dd>A callback function that takes a {{domxref("GeolocationPosition")}} object as an input parameter.</dd>
 <dt><code><var>error</var></code> {{optional_inline}}</dt>
 <dd>An optional callback function that takes a {{domxref("GeolocationPositionError")}} object as an input parameter.</dd>
 <dt><code><var>options</var></code> {{optional_inline}}</dt>
 <dd>An optional {{domxref("PositionOptions")}} object that provides configuration options for the location watch.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An integer ID that identifies the registered handler. The ID can be passed to the {{domxref("Geolocation.clearWatch()")}} to unregister the handler.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">var id, target, options;

function success(pos) {
  var crd = pos.coords;

  if (target.latitude === crd.latitude &amp;&amp; target.longitude === crd.longitude) {
    console.log('Congratulations, you reached the target');
    navigator.geolocation.clearWatch(id);
  }
}

function error(err) {
  console.warn('ERROR(' + err.code + '): ' + err.message);
}

target = {
  latitude : 0,
  longitude: 0
};

options = {
  enableHighAccuracy: false,
  timeout: 5000,
  maximumAge: 0
};

id = navigator.geolocation.watchPosition(success, error, options);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Geolocation', '#dom-geolocation-watchposition', 'watchPosition()')}}</td>
   <td>{{Spec2('Geolocation')}}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Geolocation.watchPosition")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Geolocation_API/Using">Using the Geolocation API</a></li>
 <li>The interface it belongs to, {{domxref("Geolocation")}}, and the way to access it — {{domxref("NavigatorGeolocation.geolocation")}}.</li>
 <li>The opposite operation: {{domxref("Geolocation.clearWatch()")}}</li>
 <li>A similar method: {{domxref("Geolocation.getCurrentPosition()")}}</li>
</ul>
